function [L,i] = getCorrectTellerLine(L1,L2)

L1 = L1/norm(L1(1:3));
L2 = L2/norm(L2(1:3));

vDist1 = norm(cross(L1(1:3),[0;0;1]));
vDist2 = norm(cross(L2(1:3),[0;0;1]));

dDist1 = norm(L1(4:6));
dDist2 = norm(L2(4:6));

if (vDist1<vDist2) && (dDist1<dDist2) 
    i = 2;
    L = L2;    
else
    if (vDist2<vDist1) && (dDist2<dDist1)
        L = L1;
        i = 1;
    else
        disp('Error selecting teller line');
    end        
end

return;
    
    