function lambda = twoConicsIntersection(c,d,thresh)
% x = [
%        lambda1^2;
%  lambda1*lambda2;
%          lambda1;
%        lambda2^2;
%          lambda2;
%                1];

% [ lambda1^4, lambda1^3, lambda1^2, lambda1, 1]
ccc = [
                                                                                                                                                                                                                                                                                                                                               - 16*c(1)^2*c(4)^2*d(4)^2 + 16*c(1)*c(2)*c(4)^2*d(2)*d(4) + 32*c(1)*c(4)^3*d(1)*d(4) - 16*c(1)*c(4)^3*d(2)^2 - 16*c(2)^2*c(4)^2*d(1)*d(4) + 16*c(2)*c(4)^3*d(1)*d(2) - 16*c(4)^4*d(1)^2;
                                                                                                                                                                16*c(2)*c(4)^3*d(2)*d(3) - 32*c(4)^4*d(1)*d(3) - 16*c(3)*c(4)^3*d(2)^2 - 32*c(1)*c(4)^3*d(2)*d(5) + 32*c(1)*c(4)^3*d(3)*d(4) + 16*c(2)*c(4)^3*d(1)*d(5) + 32*c(3)*c(4)^3*d(1)*d(4) + 16*c(4)^3*c(5)*d(1)*d(2) - 32*c(1)*c(3)*c(4)^2*d(4)^2 - 16*c(2)^2*c(4)^2*d(3)*d(4) + 16*c(2)*c(3)*c(4)^2*d(2)*d(4) + 16*c(1)*c(2)*c(4)^2*d(4)*d(5) + 16*c(1)*c(4)^2*c(5)*d(2)*d(4) - 32*c(2)*c(4)^2*c(5)*d(1)*d(4);
 16*c(2)*c(4)^3*d(2)*d(6) - 16*c(1)*c(4)^3*d(5)^2 - 16*c(4)^3*c(6)*d(2)^2 - 16*c(3)^2*c(4)^2*d(4)^2 - 32*c(4)^4*d(1)*d(6) - 16*c(4)^4*d(3)^2 + 16*c(2)*c(4)^3*d(3)*d(5) - 32*c(3)*c(4)^3*d(2)*d(5) + 32*c(3)*c(4)^3*d(3)*d(4) + 16*c(4)^3*c(5)*d(2)*d(3) + 32*c(1)*c(4)^3*d(4)*d(6) + 16*c(4)^3*c(5)*d(1)*d(5) + 32*c(4)^3*c(6)*d(1)*d(4) - 32*c(1)*c(4)^2*c(6)*d(4)^2 - 16*c(4)^2*c(5)^2*d(1)*d(4) - 16*c(2)^2*c(4)^2*d(4)*d(6) + 16*c(2)*c(3)*c(4)^2*d(4)*d(5) - 32*c(2)*c(4)^2*c(5)*d(3)*d(4) + 16*c(2)*c(4)^2*c(6)*d(2)*d(4) + 16*c(3)*c(4)^2*c(5)*d(2)*d(4) + 16*c(1)*c(4)^2*c(5)*d(4)*d(5);
                                                                                                                                                                16*c(2)*c(4)^3*d(5)*d(6) - 32*c(4)^4*d(3)*d(6) - 16*c(3)*c(4)^3*d(5)^2 + 32*c(3)*c(4)^3*d(4)*d(6) + 16*c(4)^3*c(5)*d(2)*d(6) + 16*c(4)^3*c(5)*d(3)*d(5) - 32*c(4)^3*c(6)*d(2)*d(5) + 32*c(4)^3*c(6)*d(3)*d(4) - 32*c(3)*c(4)^2*c(6)*d(4)^2 - 16*c(4)^2*c(5)^2*d(3)*d(4) - 32*c(2)*c(4)^2*c(5)*d(4)*d(6) + 16*c(2)*c(4)^2*c(6)*d(4)*d(5) + 16*c(3)*c(4)^2*c(5)*d(4)*d(5) + 16*c(4)^2*c(5)*c(6)*d(2)*d(4);
                                                                                                                                                                                                                                                                                                                                               - 16*c(4)^4*d(6)^2 + 16*c(4)^3*c(5)*d(5)*d(6) + 32*c(4)^3*c(6)*d(4)*d(6) - 16*c(4)^3*c(6)*d(5)^2 - 16*c(4)^2*c(5)^2*d(4)*d(6) + 16*c(4)^2*c(5)*c(6)*d(4)*d(5) - 16*c(4)^2*c(6)^2*d(4)^2];
 
lambda1 = roots(ccc')';

realRoots = zeros(1,numel(lambda1));
for k =1:numel(lambda1)
    realRoots(k) = isreal(lambda1(k));
end

lambda1Real = lambda1(realRoots>0);
nSol = numel(lambda1Real);

lambda2_cc =  [ d(4)*ones(1,nSol); d(5)*ones(1,nSol) + d(2)*lambda1Real; d(1)*lambda1Real.^2 + d(3)*lambda1Real + d(6)];

lambda2A = (-lambda2_cc(2,:) + sqrt(lambda2_cc(2,:).^2-4*lambda2_cc(1,:).*lambda2_cc(3,:)))/2./lambda2_cc(1,:);
lambda2B = (-lambda2_cc(2,:) - sqrt(lambda2_cc(2,:).^2-4*lambda2_cc(1,:).*lambda2_cc(3,:)))/2./lambda2_cc(1,:);


xHatA = [lambda1Real.^2;lambda1Real.*lambda2A;lambda1Real;lambda2A.^2;lambda2A;ones(1,numel(lambda1Real))];
xHatB = [lambda1Real.^2;lambda1Real.*lambda2B;lambda1Real;lambda2B.^2;lambda2B;ones(1,numel(lambda1Real))];



resA = c'*xHatA;
resB = c'*xHatB;


lambdaA = [lambda1Real;lambda2A];
lambdaB = [lambda1Real;lambda2B];


lambda = [lambdaA(:,abs(resA)<thresh) lambdaB(:,abs(resB)<thresh)];



% lambda2_cc = [ d(4); d(5) + d(2)*lambda1; d(1)*lambda1^2 + d(3)*lambda1 + d(6)];
 
% lambda2A = (-lambda2_cc(2) + sqrt(lambda2_cc(2)^2-4*lambda2_cc(1)*lambda2_cc(3)))/2/lambda2_cc(1);
% lambda2B = (-lambda2_cc(2) - sqrt(lambda2_cc(2)^2-4*lambda2_cc(1)*lambda2_cc(3)))/2/lambda2_cc(1);

return;