function [x y zUp zDown] = plotMirror(xMinMax,yMinMax,A,B,C)

[x y] = meshgrid(xMinMax,yMinMax);
[m n] = size(x);
x = reshape(x,m*n,1);
y = reshape(y,m*n,1);

zUp = (-B+sqrt(B^2-4*A*(x.^2+y.^2-C)))/2/A;
zDown = (-B-sqrt(B^2-4*A*(x.^2+y.^2-C)))/2/A;

x = reshape(x,m,n);
y = reshape(y,m,n);

zUp = reshape(zUp,m,n);
zDown = reshape(zDown,m,n);

